CSEG	SEGMENT	PARA	PUBLIC 'CODE'
	ORG	100H
ASSUME	CS:CSEG,DS:CSEG,ES:CSEG,SS:CSEG

PROGRAM	PROC	NEAR
	JMP	START

DESIGN	DB	'Designed by Glenn Snow   '
MEMO	DB	' '
	DB	' '
TBUFF	DB	4 DUP (?)
VAL	DW	?
ELOFS	DW	?
C1	DW	?
C2	DW	?
MSG1	DB	0DH,0AH,'The current errorlevel is:  $'
MSG2	DB	0DH,0AH,24H
MSG3	DB	0DH,0AH,'Sorry, this version only works with DOS 3.1, 3.2, 3.3, ' 
	DB	'4.0, 5.0, 6.0, and 6.2$'
MSG4	DB	0DH,0AH,'A secondary command processor has been loaded.',0DH,0AH
	DB	'The errorlevel in the primary command processor is:  $'
MSG5	DB	'The errorlevel in the CURRENT command processor is:  $'

START:	MOV	AH,30H			;set up to get DOS version
	INT	21H			;go get it
        CMP     AX,1406H                ;is it version 6.2?
        JZ      V620                    ;if so, jump to V620
        CMP     AX,0006H                ;is it version 6.0?
        JZ      V600                    ;if so, jump to V600
	CMP	AX,0005H		;is it version 5.0  ?
	JZ	V500			;if so, jump to V500
	CMP	AX,0004H		;is it version 4.0  ?
	JZ	V400			;if so, jump to v400
	CMP	AX,1E03H		;is it version 3.3  ?
	JZ	V330			;if so, jump to v330
	CMP	AX,1403H		;is it version 3.2  ?
	JZ	V320			;if so, jump to v320
	CMP	AX,0A03H		;is it version 3.1 ?
	JZ	V310			;if so, jump to v310
	JMP	WRONGVER		;otherwise, jump to wrongver message

V620:   MOV     ELOFS,036BH             ;load 6.2 errorlevel flag offset
        JMP     CONT1                   ;and continue
	
V600:   MOV     ELOFS,0366H             ;load 6.2 errorlevel flag offset
        JMP     CONT1                   ;and continue
	
V500:	MOV	ELOFS,02A3H		;load 5.0 errorlevel flag offset
	JMP	CONT1			;and continue
	
V400:   MOV     ELOFS,0F2CH		;load 4.0 errorlevel flag offset
	JMP	CONT1			;and continue
	
V330:	MOV	ELOFS,0BEAH		;load 3.3 errorlevel flag offset
	JMP	CONT1			;and continue

V320:	MOV	ELOFS,0AFAH		;load 3.2 errorlevel flag offset
	JMP	CONT1			;and continue

V310:	MOV	ELOFS,0AC8H		;load 3.1 errorlevel flag offset
	JMP	CONT1			;and continue

CONT1:	MOV	AX,352Eh		;set up to get primary COMMAND.COM seg
	INT	21h			;and go get it  (address of int 2Eh)
	MOV	C1,ES			;save the segment in variable C1
	MOV	AX,3523h		;set up to get second COMMAND.COM seg
	INT	21H			;and go get it (address of int 23h)
	MOV	C2,ES			;save the segment in variable C2
	PUSH	ES			;put this segment...
	POP	AX			;into AX register, and
	CMP	AX,C1			;compare it to first one
	JZ	SINGLE			;if same, then only one COMMAND.COM
	MOV	DX,OFFSET MSG4		;otherwise, set up to notify user
	CALL	OUTMSG			;tell user of secondary COMMAND.COM
	MOV	AX,C1			;move primary address into ax
	PUSH	AX			;and then load it into
	POP	DS			;DS to get errorlevel
	CALL	GETEL			;go find the errorlevel and report
	MOV	DX,OFFSET MSG5		;now do the same for the secondary
	CALL	OUTMSG			;command processor...first the msg
	MOV	AX,C2			;then the
	PUSH	AX			;
	POP	DS			;
	CALL	GETEL			;secondary errorlevel message
	JMP	EXIT			;and jump to the quit routine

WRONGVER:
	MOV	VAL,0			;set up new errorlevel as zero
	MOV	DX,OFFSET MSG3		;load the error message
	CALL	OUTMSG			;and send it out
	JMP	EXIT			;then exit routine

SINGLE:	MOV	DX,OFFSET MSG1		;load the message
	CALL	OUTMSG			;and send it out
	MOV	AX,C1			;get primary COMMAND address
	PUSH	AX			;and put it
	POP	DS			;into DS
	CALL	GETEL			;then get errorlevel and report
	JMP	EXIT			;now jump to exit routine

GETEL:	PUSH	DS			;save the DS register
	PUSH	CS			;and load the CS register
	POP	DS			;into DS instead
	MOV	SI,ELOFS		;now get the ERRORLEVEL flag offset
	POP	DS			;and restore DS
	LODSB				;load the flag into AL
	PUSH	CS			;and now reload the CS register
	POP	DS			;into DS
	MOV	VAL,AX			;and save the errorlevel for our exit
	MOV	DX,VAL			;set up to print the errorlevel
	CALL	OUTVAL			;and send it out
	MOV	DX,OFFSET MSG2		;set up to print out blank line
	CALL	OUTMSG			;and go print it
	RET				;now go back to where you came from

OUTVAL:	MOV	CX,0			;These routines just 
	MOV	DI,OFFSET TBUFF		;  print out the values
DEC8OUT1:				;  in a readable (decimal) manner.
	PUSH	CX			;
	MOV	AL,DL			;  They were basically stolen
	MOV	AH,0			;  from the "Bluebook of Assembly
	MOV	CL,10			;  Routines" published by
	DIV	CL			;  The Waite Group
	MOV	DL,AL			;
	MOV	AL,AH			;
	ADD	AL,30H			;
	MOV	[DI],AL			;
	INC	DI			;
	POP	CX			;
	INC	CX			;
	CMP	DL,0			;
	JNZ	DEC8OUT1		;

DEC8OUT2:
	DEC	DI			;  More stolen routines
	MOV	AL,[DI]
	CALL	STDOUT
	LOOP	DEC8OUT2
	RET

STDOUT:	PUSH	DX			;  And yet again
	MOV	DL,AL
	MOV	AH,2
	INT	21H
	POP	DX
	RET

OUTMSG:	PUSH	AX			;  Still...
	MOV	AH,9
	INT	21H
	POP	AX
	RET

EXIT:	MOV	AX,VAL			;And FINALLY, the exit routine
	MOV	AH,4CH			; leaves the ERRORLEVEL unchanged
	INT	21H			; from when we entered this program

PROGRAM	ENDP
CSEG	ENDS
	END	PROGRAM
