// GENTREE.H
// Copyright (C) Paul Kimmel 1994
// All Rights Reserved

/***********************************************************************
 GENTREE - Lets you design your own customized OS commands.  GENTREE simply
 traverses a DOS tree given a starting path and the res is up to you.
 Have you ever wanted to delete all *.BAK files on a disk? Well with
 GENTREE you can run. For example, executing GENTREE with the following
 arguments: GENTREE C: DEL *.BAK will search the entire disk executing
 the program DEL with arguments *.BAK. Simply follow the syntax required
 by GENTREE and it will do whatever you want it to.

 SYNTAX: gentree path prog_name arg1,arg2,arg3...
 Where path is any starting DOS path (e.g. C:, C:\DOS, D:\DOC)
 Where prog_name is any non-TSR executable, command, or batch program
 Where arg1,arg2 etc... are arguments you want that program (progr_name)
	to use as its arguments.

 The second way to use GENTREE is with the source code. The sample executable
 program bundled with GENTREE does what is mentioned above. But provide
 GENTREE with your own function and it becomes something completely new.

 Just follow the example in the source code adding your function argument
 and compile and link.

 GENTREE is available in PASCAL for 19.95 + shipping and handling.
 *************************************************************************/

#if !defined(__GENTREE_H)
#define __GENTREE_H
// The general tree starting point
void GenTree( void (*f)(), char* );

#endif